package sun.java2d.loops;

import sun.java2d.SurfaceData;
import sun.java2d.SunGraphics2D;

public class FillRect extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    
    public static FillRect locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (FillRect)GraphicsPrimitiveMgr.locate(FillRect.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    protected FillRect(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(FillRect.methodSignature, FillRect.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public FillRect(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, FillRect.methodSignature, FillRect.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void FillRect(SunGraphics2D p0, SurfaceData p1, int p2, int p3, int p4, int p5);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return new General(surfaceType, compositeType, surfaceType2);
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new FillRect.TraceFillRect(this);
    }
    
    static {
        methodSignature = "FillRect(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
        GraphicsPrimitiveMgr.registerGeneral(new FillRect(null, null, null));
    }
    
    public static class General extends FillRect
    {
        public MaskFill fillop;
        
        public General(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
            super(surfaceType, compositeType, surfaceType2);
            this.fillop = MaskFill.locate(surfaceType, compositeType, surfaceType2);
        }
        
        @Override
        public void FillRect(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, int n, int n2, int n3, int n4) {
            this.fillop.MaskFill(sunGraphics2D, surfaceData, sunGraphics2D.composite, n, n2, n3, n4, null, 0, 0);
        }
    }
    
    private static class TraceFillRect extends FillRect
    {
        FillRect target;
        
        public TraceFillRect(FillRect target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void FillRect(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, int n, int n2, int n3, int n4) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.FillRect(sunGraphics2D, surfaceData, n, n2, n3, n4);
        }
    }
}
